//AlignerContour_502f.js
// 23.05.10 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Modifier l'alignement des contours de blocs slectionnes de "centrer"  "intrieur" (et vice versa) et adapte la position et les dimensions des objets

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester si un document est ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// slectionner le point de rfrence au centre
var trp = app.layoutWindows[0].transformReferencePoint;
if (trp != 1095656308) {
	app.layoutWindows[0].transformReferencePoint = 1095656308;
}

// tester la slection
var curSel = app.selection;
var nSel = curSel.length;

if (nSel == 0) {
	alert ("Il n'y a pas de slection.", "Stop");
	reStore(trp);
	exit();
}
else {
	modSel(curSel, nSel);
}

// appeler la fonction pour rtablir le point de rfrence 
reStore(trp);

function modSel(curSel, nSel) {
	var actType;
	var actFrame;
	var curFrame;
	var curType;
	var topGroup;
	var unLock;
	var unLockParent;
	for (var i=0; i<nSel; i++) {
		// mettre la rfrence du bloc actuel dans la variable 'curFrame'
		curFrame = curSel[i];
		// mmoriser le type du bloc
		curType = curFrame.constructor.name;
		// les objets qui ne sont pas des groupes sont passs  la fonction 
		// 'modFrame', sinon  la fonction 'modGroup'
		if (curType != "Group") {
			// si le bloc n'est pas slectionn directement, relever la rfrence 
			// (= pour faire plaisir  l'utilisateur :-)
			if (curType == "InsertionPoint" || curType == "Character" || curType == "Text" 
				|| curType == "Word" || curType == "Line" || curType == "Paragraph" 
				|| curType == "TextStyleRange" || curType == "TextColumn") {
				curFrame = curFrame.parentTextContainers[0];
			}
			// exclure les filets
			if (curType != "GraphicLine") {
				unLock = false;
				unLockParent = false;
				if (curFrame.locked == true) {
					unLock = true;
					try {
						curFrame.locked = false;
					}
					catch (e) {
						unLockParent = true;
						actType = "Group";
						actFrame = curFrame.parent;
						while (actType == "Group") {
							actType = actFrame.constructor.name;
							if (actType == "Group") {
								topGroup = actFrame;
							}
							try {
								actFrame.parent.locked = false;
							}
							catch (e) {
							}
							actFrame = actFrame.parent;
						}
					}
				}
				modFrame(curFrame);
				if (unLockParent == true) {
					try {
						topGroup.locked = true;
					}
					catch (e) {
					}
				}
				else if (unLock == true) {
					try {
						curFrame.locked = true;
					}
					catch (e) {
					}
				}
			}
		}
		else {
			unLock = false;
			if (curFrame.locked == true) {
				unLock = true;
				try {
					curFrame.locked = false;
				}
				catch (e) {
					alert ("Il faut liberer les blocs verrouills.", "Stop");
					reStore(trp);
					exit();
				}
			}
			modGroup(curFrame);
			if (unLock == true) {
				try {
					curFrame.locked = true;
				}
				catch (e) {
				}
			}
		}
	}
}

function modGroup(curGroup) {
	var allFrames = curGroup.allPageItems;
	var nFrames = allFrames.length; 
	var unLock;
	for (var i=0; i< nFrames; i++) {
		curFrame = allFrames[i];
		curType = curFrame.constructor.name;
		if (curType != "Group") {
			if (curType != "GraphicLine") {
				unLock = false;
				if (curFrame.locked == true) {
					unLock = true;
					try {
						curFrame.locked = false;
					}
					catch (e) {
						alert ("Il faut liberer les blocs verrouills.", "Stop");
						reStore(trp);
						exit();
					}
				}
				modFrame(curFrame);
				if (unLock == true) {
					try {
					curFrame.locked = true;
					}
					catch (e) {
					}
				}
			}
		}
	}
}

function modFrame(curFrame) {
	var curAlign = curFrame.strokeAlignment;
	// ne traiter que des blocs dont l'alignement est "centrer" ou "sur l'intrieur"
	if (curAlign == StrokeAlignment.insideAlignment || curAlign == StrokeAlignment.centerAlignment) {
		try {
			// Mettre les angles de rotation et/ou de dformation  zro (si ncessaire)
			var curRot = curFrame.rotationAngle;
			if (curRot != 0) {
				curFrame.rotationAngle = 0;
			}
			var curShear = curFrame.shearAngle;
			if (curShear != 0) {
				curFrame.shearAngle = 0;
			}
			if (curAlign == StrokeAlignment.insideAlignment) {
				// modifier l'alignement  "centrer" 
				curFrame.strokeAlignment = StrokeAlignment.centerAlignment;
				// appliquer les nouvelles valeurs des bords
				curFrame.visibleBounds = curFrame.geometricBounds;
			}
			else if (curAlign == StrokeAlignment.centerAlignment) {
				// appliquer les nouvelles valeurs des bords
				curFrame.geometricBounds = curFrame.visibleBounds;
				// modifier l'alignement  "sur l'intrieur" 
				curFrame.strokeAlignment = StrokeAlignment.insideAlignment;
			}
			// rtablir les angles de rotation et/ou de dformation
			if (curRot != 0) {
				curFrame.rotationAngle = curRot;
			}
			if (curShear != 0) {
				curFrame.shearAngle = curShear;
			}
		}
		catch (e) {
			alert ("Il faut liberer les blocs verrouills.", "Stop");
			reStore(trp);
			exit();
		}
	}
}

// rtablir le point de rfrence (si ncessaire)
function reStore(trp) {
	if (trp != 1095656308) {
		app.layoutWindows[0].transformReferencePoint = trp;
	}
}